//----------------------------------------------------------------------//
// etH[}bg̃t@C擾									//
//																		//
//----------------------------------------------------------------------//
#ifndef UsrFileInfH
#define UsrFileInfH

//---------------------------------------------------------------------------
#include <vcl.h>

//---------------------------------------------------------------------------
#define FILE_RBUF_SIZE	32768		//t@Cǂݍݗpobt@TCY(32KB)

//---------------------------------------------------------------------------
void add_list_errmsg(TStringList *lst, UnicodeString msg);

UnicodeString get_id_str4(TFileStream *fs);
bool sea_chunk(TFileStream *fs, const char *s);
UnicodeString get_chunk_hdr(TFileStream *fs, unsigned int *size = NULL);

//---------------------------------------------------------------------------
void get_WavInf(UnicodeString fnam, TStringList *lst);
void get_OpusInf(UnicodeString fnam, TStringList *lst);
bool get_CdaInf(UnicodeString fnam, TStringList *lst, int *len = NULL);
bool get_FlacInf(UnicodeString fnam, TStringList *lst = NULL, int *len = NULL, bool id_min = false);
bool get_FlacImage(UnicodeString fnam, Graphics::TBitmap *bmpimg, UnicodeString o_fnam = EmptyStr);

//---------------------------------------------------------------------------
UnicodeString get_wd_x_hi_str(int w, int h);
UnicodeString get_img_size_str(int w, int h, UnicodeString name = EmptyStr);

void get_JpgExInf(UnicodeString fnam, TStringList *lst);

bool get_ExifInf(UnicodeString fnam, TStringList *lst, int *ori = NULL, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL);
UnicodeString get_ExifInfStr(UnicodeString fnam, int *ori = NULL, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL);
UnicodeString get_ExifInfThumb(UnicodeString fnam, int *ori);
bool get_GpsInf(UnicodeString fnam, double *lat, double *lng);

void get_MetafileInf(UnicodeString fnam, TStringList *lst);
bool get_PngInf(UnicodeString fnam, TStringList *lst, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL);
UnicodeString get_PngInfStr(UnicodeString fnam, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL);
bool get_GifInf(UnicodeString fnam, TStringList *lst, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL, int *i_cnt = NULL);
bool get_WebpInf(UnicodeString fnam, TStringList *lst, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL);
UnicodeString get_WebpInfStr(UnicodeString fnam, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL);

bool get_PspInf(UnicodeString fnam, TStringList *lst, unsigned int *i_wd = NULL, unsigned int *i_hi = NULL);
bool get_PspThumbnail(UnicodeString fnam, Graphics::TBitmap *bmpimg);

//---------------------------------------------------------------------------
void get_IconInf(UnicodeString fnam, TStringList* lst, int *ico_n = NULL);
bool get_AniInf(UnicodeString fnam, TStringList *lst);

//---------------------------------------------------------------------------
void get_AppInf(UnicodeString fnam, TStringList *lst, bool check = true);
bool get_DllExpFunc(UnicodeString fnam, TStringList *lst);
void get_BorlandInf(UnicodeString fnam, TStringList *lst);
void get_TagsInf(UnicodeString fnam, TStringList *lst);

//---------------------------------------------------------------------------
UnicodeString get_html_header(UnicodeString fnam, int code_page = 0);
void get_HtmlInf(UnicodeString fnam, TStringList *lst);

//---------------------------------------------------------------------------
UnicodeString get_CRC32_str(UnicodeString fnam);
UnicodeString get_HashStr(UnicodeString fnam, ALG_ID algid);
UnicodeString get_HashStr(UnicodeString fnam, UnicodeString idstr);

//---------------------------------------------------------------------------
#endif
