//----------------------------------------------------------------------//
// bZ[W															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <System.StrUtils.hpp>
#include "usr_str.h"
#include "usr_msg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//bZ[W̎擾
//---------------------------------------------------------------------------
UnicodeString LoadUsrMsg(int id, UnicodeString s)
{
	std::unique_ptr<TStringList> msg_lst(new TStringList());
	msg_lst->Text =
		"1001=%s܂B\n"							//USTR_NotFound
		"1002=%s̑ɂ͑ΉĂ܂B\n"				//USTR_OpeNotSuported
		"1003=̑͂ł܂B\n"							//USTR_CantOperate
		"1004=ΉĂȂ`łB\n"						//USTR_FmtNotSuported
		"1005=ꎞ𓀂Ɏs܂B\n"						//USTR_FaildTmpUnpack
		"1006=ړ悪łB\n"								//USTR_SameMoveDest
		"1007=Rs[悪łB\n"							//USTR_SameCopyDest
		"1008=fBNg܂܂Ă܂B\n"					//USTR_IncludeDir
		"1009=sȓt܂͎łB\n"						//USTR_IllegalDate
		"1010=sȎwłB\n"								//USTR_IllegalParam
		"1011=sȌ`łB\n"								//USTR_IllegalFormat
		"1012=sȃAhXł\n"								//USTR_IllegalAddress
		"1013=NɎs܂B\n"							//USTR_FaildExec
		"1014=Ɏs܂B\n"							//USTR_FaildProc
		"1015=ǂݍ݂Ɏs܂B\n"						//USTR_FaildLoad
		"1016=%s̕ۑɎs܂B\n"						//USTR_FaildSave
		"1017=폜Ɏs܂B\n"							//USTR_FaildDelete
		"1018=Rs[Ɏs܂B\n"							//USTR_FaildCopy
		"1019=j[sł܂B\n"						//USTR_FaildMenu
		"1020=f܂B\n"									//USTR_Canceled
		"1021=[NXgJ܂B\n"						//USTR_WlistCantOpen
		"1022=ɂ̑͂ł܂B\n"					//USTR_ProcBusy
		"1023=Ώۂ܂B\n"								//USTR_NoObject
		"1024=K\Ɍ肪܂B\n"						//USTR_IllegalRegEx
		"1025=̓\n"								//USTR_InputFmtStr
		"1026=łɓo^Ă܂B\n"						//USTR_Registered
		"1027=@...^@ESCL[Œf܂B\n"			//USTR_SearchingESC
		"1028=@vZ...^@ESCL[Œf܂B\n"			//USTR_CalculatingESC
		"1029=@...^@΂炭B\n"		//USTR_WaitForReady
		"1030=X|Xt@C̍쐬Ɏs܂B\n"		//USTR_FaildListFile
		"1031=ꎞfBNg쐬ł܂B\n"				//USTR_CantMakeTmpDir
		"1032=sȍ\łB\n"								//USTR_SyntaxError
		"1033=Ή鐧䕶܂B\n"				//USTR_BadStatmet
		"1034=p[^w肳Ă܂B\n"				//USTR_NoParameter
		"1035=AvP[V܂B\n"				//USTR_AppNotFound
		"1036=摜̏łĂ܂B\n"					//USTR_ImgNotReady
		"1037=t@CJ܂B\n"							//USTR_FileNotOpen
		"1038=fBNg܂B\n"					//USTR_DirNotFound
		"1039=ȃR}hłB\n"							//USTR_InvalidCmd
		"1040=. ŋ؂ĕw\\n"						//USTR_HintMltFExt
		"1041=; ŋ؂ĕw\\n"						//USTR_HintMltSepSC
		"1042=ΉGfB^܂\n"					//USTR_NoEditor
		"1043=Đł܂B\n"								//USTR_CantPlay
		"1044=%sɖOtĕۑ\n"							//USTR_SaveAs
		"1045=fBNg[%s]쐬ł܂B\n"				//USTR_CantCreDir
		"1046=%sRs[܂?\n"							//USTR_CopyQ
		"1047=%s폜܂?\n"								//USTR_DeleteQ
		"1048=%sS폜܂?\n"							//USTR_CompDeleteQ
		"1049=%sׂ̗č폜܂?\n"					//USTR_DelHistoryQ
		"1050=ׂĂ̏ꏊׂ̂Ẵ}[N܂?\n"	//USTR_ClrAllMarkQ
		"1051=R}h𒆒f܂?\n"						//USTR_CancelCmdQ
		"1052=A[JCuJ܂B\n"						//USTR_ArcNotOpen
		"1053=eLXgt@Cł͂܂B\n"				//USTR_NotText
		"1054=%s𒊏o܂?\n"								//USTR_Extract
		"1055=%s񂪎擾ł܂B\n"						//USTR_CantGetInfo
		"1056=OdĂ܂B\n"							//USTR_DuplicateName
		"1057=㏑Ă悢ł?\n"						//USTR_OverwriteQ
		"1058=%sAbv[h܂?\n"						//USTR_UploadQ
		"1059=%s_E[h܂?\n"						//USTR_DownloadQ
		"1060=폜Jn  %s\n"									//USTR_BeginDelete
		"1061=t@C̏ <%s>\n"						//USTR_SameName
		"1062=O̕ύX\n"										//USTR_Rename
		"1063=fBNg̈قȂ铯Ώۂ݂܂B\n"	//USTR_NgSameName
		"1064=sȓtłB\n"							//USTR_IllegalDtCond
		"1065=I}XÑ[NXg͕ύXł܂B\n"	//USTR_WorkFiltered
		"1066=EfBNgłB\n"					//USTR_SameDirLR
		"1067=plB\n"								//USTR_HideOptPanel
		"1068=pl\\n"								//USTR_ShowOptPanel

		"1100=I\n"										//USTR_SelectedItem
		"1101=ꗗ\n"											//USTR_List
		"1102=Abv[h\n"									//USTR_Upload
		"1103=_E[h\n";									//USTR_Download

	UnicodeString ret_str = REPLACE_TS(msg_lst->Values[IntToStr(id)], "^", "\r\n");
	ret_str = s.IsEmpty()? replace_regex(ret_str, _T("%s[̂]?"), null_TCHAR) : ReplaceStr(ret_str, "%s", s);
	return ret_str;
}
//---------------------------------------------------------------------------
UnicodeString LoadUsrMsg(int id, const _TCHAR *s)
{
	return LoadUsrMsg(id, UnicodeString(s));
}
//---------------------------------------------------------------------------
UnicodeString LoadUsrMsg(int id, int id_s)
{
	return LoadUsrMsg(id, LoadUsrMsg(id_s));
}

//---------------------------------------------------------------------------
//[U`bZ[W EAbort 𑗏o
//---------------------------------------------------------------------------
void UserAbort(unsigned id)
{
	throw EAbort(LoadUsrMsg(id));
}
//---------------------------------------------------------------------------
